#ifndef OBJ_LOADER_H_
#define OBJ_LOADER_H_

#include "vector3.h"
#include "surface.h"

/*! \fn int LoadOBJ( const char * file_name, Vector3 & default_color, std::vector<Surface *> & surfaces, std::vector<Material *> & materials )
\brief Nate geometrii z OBJ souboru \a file_name.
\note Pi exportu z 3ds max je nutn nastavit systmov jednotky na metry:
Customize -> Units Setup Metric (Meters)
System Unit Setup -> 1 Unit = 1,0 m a zakrtnout Respect System Units in File
\see 
\param file_name pln cesta k OBJ souboru vetn ppony.
\param surfaces pole ploch, do kterho se budou ukldat naten plochy.
\param materials pole materil, do kterho se budou ukldat naten materily.
\param flip_yz rotace kolem osy x o + 90st.
\param default_color vchoz barva vertexu.
*/
int LoadOBJ( const char * file_name, std::vector<Surface *> & surfaces, std::vector<Material *> & materials,
	const bool flip_yz = false, const Vector3 default_color = Vector3( 0.5f, 0.5f, 0.5f ) );

#endif
