#ifndef TRIANGLE_H_
#define TRIANGLE_H_

#include "vertex.h"

class Surface; // dopedn deklarace tdy

/*! \class Triangle
\brief A class representing single triangle in 3D.

\author Tom Fabin
\version 1.1
\date 2013-2018
*/
class Triangle
{
public:	
	//! Vchoz konstruktor.
	/*!
	Inicializuje vechny sloky trojhelnku na hodnotu nula.
	*/
	Triangle() { }

	//! Obecn konstruktor.
	/*!
	Inicializuje trojhelnk podle zadanch hodnot parametr.

	\param v0 prvn vrchol trojhelnka.
	\param v1 druh vrchol trojhelnka.
	\param v2 tet vrchol trojhelnka.
	\param surface ukazatel na plochu, j je trojhelnk lenem.
	*/
	Triangle( const Vertex & v0, const Vertex & v1, const Vertex & v2, Surface * surface = NULL );

	//! I-t vrchol trojhelnka.
	/*!
	\param i index vrcholu trojhelnka.

	\return I-t vrchol trojhelnka.
	*/
	Vertex vertex( const int i );	

	bool is_degenerate() const;

private:
	Vertex vertices_[3]; /*!< Vrcholy trojhelnka. Nic jinho tu nesm bt, jinak padne VBO v OpenGL! */	
};

#endif
