#ifndef VERTEX_H_
#define VERTEX_H_

#include "structs.h"
#include "vector3.h"

/*! \def NO_TEXTURE_COORDS
\brief Poet texturovacch souadnic.
*/
#define NO_TEXTURE_COORDS 1

//class Surface;

/*! \struct Vertex
\brief Struktura popisujc vechny atributy vertexu.

\author Tom Fabin
\version 1.0
\date 2013
*/
struct /*ALIGN*/ Vertex
{
public:
	Vector3 position; /*!< Pozice vertexu. */
	Vector3 normal; /*!< Normla vertexu. */
	Vector3 color; /*!< RGB barva vertexu <0, 1>^3. */
	Coord2f texture_coords[NO_TEXTURE_COORDS]; /*!< Texturovac souadnice. */
	Vector3 tangent; /*!< Prvn osa souadnho systmu tangenta-bitangenta-normla. */

	//char pad[8]; // doplnn na 64 byt, mlo by to mt alespo 4 byty, aby se sem veel 32-bitov ukazatel

	//! Vchoz konstruktor.
	/*!
	Inicializuje vechny sloky vertexu na hodnotu nula.
	*/
	Vertex() { }

	//! Obecn konstruktor.
	/*!
	Inicializuje vertex podle zadanch hodnot parametr.

	\param position pozice vertexu.
	\param normal normla vertexu.
	\param color barva vertexu.
	\param texture_coords nepovinn ukazatel na pole texturovacch souadnic.
	*/
	Vertex( const Vector3 position, const Vector3 normal, Vector3 color, Coord2f * texture_coords = NULL );

	//void Print();
};

#endif
